import bpy
from bpy.types import Gizmo
from mathutils import Matrix, Vector
from gpu import state
from math import sqrt
from ... import get_prefs


class GP_GT_searcher(Gizmo):
    bl_idname = 'GP_GT_searcher'

  
    __slots__ = (
        'shape',
    )


    def setup(self):
        
        arrow = [
            (0.0, 0.0, 0.0), (0.5, -1.5, 0.0), (0.0, -2.0, 0.0),
            (0.0, 0.0, 0.0), (0.0, -2.0, 0.0), (-0.5, -1.5, 0.0),
        ]

        if not hasattr(self, 'shape'):
            self.shape = self.new_custom_shape('TRIS', arrow)

        self.use_draw_offset_scale = True 
        self.use_draw_modal = True
        self.use_tooltip = False # не отображать description
        self.use_grab_cursor = False #draw grab cursor
        #self.use_select_background = True
        
        
    def draw(self, context):
        #if self.align_view:
        #    self.matrix_basis = view_orient_matrix(self.matrix_basis.translation)[0] #@ Matrix.Translation( Vector( (0.0, 0.0, 5.0) ) )
        #self.matrix_offset = Matrix.Translation(Vector((0.0, 0.0, -10)))

        state.blend_set('ALPHA')
        #line_width = 2 * self.props.size_gizmo_pro * self.dpi
        #state.line_width_set(line_width)

        self.draw_custom_shape(self.shape)

        #state.line_width_set(1.0)
        state.blend_set('NONE')


   


    def test_select(self, context, location):
        prefs = context.preferences.system
        dpi = (prefs.dpi * prefs.pixel_size / 72)
        pos = self.matrix_basis.translation
        out = self.scale_basis * dpi * 2

        sqx = (location[0] - pos[0])**2
        sqy = (location[1] - pos[1])**2

        if sqrt(sqx + sqy) < out:
            return 0

        return -1







classes = [
    GP_GT_searcher,
]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)