import bpy
from ...utils.draw_utils.draw import get_triangle_sliding, draw_batch_mat
from ...utils.pro_types import GizmoPRO
from ... import var
from gpu import state
from bpy.types import Gizmo



class GP_GT_blank(Gizmo):
    bl_idname = 'GP_GT_blank'


    __slots__ = (
        'lines',
        'tri',
    )


    def setup(self):
        self.use_draw_offset_scale = True 
        self.use_draw_modal = True
        self.use_tooltip = False
        self.use_grab_cursor = False
        if not hasattr(self, 'lines'):
            lines, tri = get_triangle_sliding((0.0,0.0), 1, 0.5)
            self.tri = self.new_custom_shape('TRIS', tri)
            self.lines = self.new_custom_shape('LINES', lines)


    def draw(self, context):
        state.blend_set('ALPHA')
        state.line_width_set(self.line_width)
        
        init_alpha = self.alpha
        self.alpha = self.alpha/2
        self.draw_custom_shape(self.tri)
        self.alpha = init_alpha
        self.draw_custom_shape(self.lines)

        state.line_width_set(1.0)
        state.blend_set('NONE')

  
    def draw_select(self, context, select_id):
        self.draw_custom_shape(self.tri, select_id=select_id)



classes = [
    GP_GT_blank,
    ]

def register():
    for cls in classes:
        bpy.utils.register_class(cls)

def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)