import bpy
from bpy.types import Gizmo
from gpu import state
from ... import get_prefs


class GP_GT_pivot(Gizmo):
    bl_idname = 'GP_GT_pivot'


    __slots__ = (
        'props',
        'settings',
        'mesh',
        'shape',
    )
    

    def setup(self):
        self.props = get_prefs()
        self.settings = bpy.context.scene.GP_scene_set
      
        self.use_draw_offset_scale = True 
        self.use_draw_modal = True
        self.use_tooltip = False # не отображать description
        #self.use_operator_tool_properties = True
        self.use_grab_cursor = False #draw grab cursor
        #self.select = True
        #self.select_bias = 1.0
        #self.use_select_background = False
        self.color = (0, 0.823, 0.415)
        self.alpha = 1.0
        

        lenght = 1.5
        offset = 0.5
        
        self.mesh = [
            (-lenght, 0.0, 0.0), (-offset, 0.0, 0.0), (lenght, 0.0, 0.0), (offset, 0.0, 0.0),
            (0.0, -lenght, 0.0), (0.0, -offset, 0.0), (0.0, lenght, 0.0), (0.0, offset, 0.0),
            (0.0, 0.0, -lenght), (0.0, 0.0, -offset), (0.0, 0.0, lenght), (0.0, 0.0, offset),
        ]
        if not hasattr(self, 'shape'):
            self.shape = self.new_custom_shape('LINES', self.mesh)
            
 
    def draw(self, context):
        state.blend_set('ALPHA')
        state.line_width_set( 3.0 * self.scale_basis * 10.0 )

        self.draw_custom_shape(self.shape)

        state.line_width_set(1.0)
        state.blend_set('ALPHA')



classes = [
    GP_GT_pivot,
    ]

def register():
    for cls in classes:
        bpy.utils.register_class(cls)

def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)