import bpy
from mathutils import Matrix, Vector, Quaternion
from bpy.types import GizmoGroup
from ..utils.poll import poll_curve
from ..matrix.matrix_ensure import get_orient_from_type, get_position
from .. import var
from ..utils.draw_utils.through import alpha_gizmo, alpha_arc_gizmo
from math import radians, atan2
from ..utils.custom_math.quaternion import look_rotation
from ..keymaps import keymaps_gizmo_tweak




class GP_GGT_curve(GizmoGroup):
    bl_label = 'Gizmo PRO'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW' 
    bl_options = {'3D', 'PERSISTENT', 'SHOW_MODAL_ALL', 'TOOL_FALLBACK_KEYMAP'} #'DEPTH_3D' , 'TOOL_INIT', 'SELECT', , 'SCALE'  , 'SHOW_MODAL_ALL' , 'PERSISTENT' , VR_REDRAWS 

    @classmethod
    def poll(cls, context):
        return poll_curve(context)

    @classmethod
    def setup_keymap(cls, keyconfig):
        return keymaps_gizmo_tweak(keyconfig)

    def setup(self, context):
        s = context.scene

    """ def invoke_prepare(self, context, gizmo):
        s = context.scene """

    """ def refresh(self, context):
        s = context.scene """

    def draw_prepare(self, context):
        s = context.scene






classes = []


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)