import bpy
from bpy.types import GizmoGroup
from ..utils.poll import poll_preselect



class GP_GGT_gizmo_preselect(GizmoGroup):

    bl_idname = 'GP_GGT_gizmo_preselect'
    bl_label = 'Preselect'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW'
    bl_options = {'3D', 'PERSISTENT'}


    @classmethod
    def poll(cls, context):
        return poll_preselect(context)


    def setup(self, context):
        self.preselect = self.gizmos.new('GP_GT_preselect')



classes = [
    GP_GGT_gizmo_preselect,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)