import bpy
from mathutils import Vector
from ...utils.custom_math.bbone import get_selected_bone_points, remove_duplicate_positions, get_active_bone_el, get_main_parent_bones_head_positions


def get_active_bone_pos():
    obj = bpy.context.object 
    bone = get_active_bone_el()
    if bone:
        l = obj.matrix_world @ bone.head
    else:
        l = Vector()
    return l


def get_median_bone_pos():
    if bpy.context.mode == 'POSE':
        points = get_main_parent_bones_head_positions()
    elif bpy.context.mode == 'EDIT_ARMATURE':
        points = get_selected_bone_points()
        points = remove_duplicate_positions(points)
    if len(points) > 0:
        l = sum(points, Vector()) / len(points)
    else:
        l = Vector()
    return l


def get_bb_bone_pos():
    if bpy.context.mode == 'POSE':
        points = get_main_parent_bones_head_positions()
    elif bpy.context.mode == 'EDIT_ARMATURE':
        points = get_selected_bone_points()
        points = remove_duplicate_positions(points)
    if len(points) > 0 :
        if bpy.context.mode == 'POSE':
            points = get_main_parent_bones_head_positions()
        x = (min([v.x for v in points]) + max([v.x for v in points])) / 2
        y = (min([v.y for v in points]) + max([v.y for v in points])) / 2
        z = (min([v.z for v in points]) + max([v.z for v in points])) / 2
        l = Vector((x, y, z))
    else:
        l = Vector()
    return l 






