import bpy
from mathutils import Vector
from ...utils.custom_math.bcurve import get_selected_curve_points, get_last_selected_point_curve_el



def get_median_curve_pos():
    points = get_selected_curve_points()
    if len(points) > 0:
        l = sum(points, Vector()) / len(points)
    else:
        l = Vector()
    return l


def get_bb_curve_pos():
    points = get_selected_curve_points()
    if len(points) > 0 :
        x = (min([v.x for v in points]) + max([v.x for v in points])) / 2
        y = (min([v.y for v in points]) + max([v.y for v in points])) / 2
        z = (min([v.z for v in points]) + max([v.z for v in points])) / 2
        l = Vector((x, y, z))
    else:
        l = Vector()
    return l


def get_active_curve_pos():
    state, p_last = get_last_selected_point_curve_el()
    ob = p_last[0]
    p = p_last[1]
    typ = p_last[2]

    if p is None:
        return Vector()

    if state == 'ACTIVE':
        if typ == 'BEZIER':
            l = ob.matrix_world @ p.co
        elif typ == 'L_HANDLE':
            l = ob.matrix_world @ p.handle_left
        elif typ == 'R_HANDLE':
            l = ob.matrix_world @ p.handle_right
        elif typ == 'NURBS':
            l = ob.matrix_world @ Vector((p.co[0], p.co[1], p.co[2]))
    else:
        l = get_bb_curve_pos()

    return l