import bpy
from bpy.types import Operator, Menu
from bpy.props import EnumProperty, BoolProperty, StringProperty
from .. import var
from .. import get_prefs

from ..utils.func import (
    get_tool,
    get_brush_size,
    get_brush_strength,
    set_brush_size,
    set_brush_strength,
    transform_orientation,
    transform_pivot_point,
    transform_snap_to,
    transform_proportional,
)





# --- OPEN Quick Widget 
class GP_OT_quick_wheel(Operator): # FIXME TODO не работате с скульпт модом
    bl_idname = 'gp.quick_wheel'
    bl_label = 'Quick Widget'
    bl_options = {'INTERNAL'}


    #pin: BoolProperty( default = False )
    ufui: BoolProperty( default = False ) 
    #close: BoolProperty( default = False )

 
    """ def check(self, context):
        return self.ufui """
    @classmethod
    def description(self, context, properties):
        #props = context.preferences.addons['GIZMO_PRO'].preferences
        settings = context.scene.GP_scene_set
        if settings.qw:
            return 'Close QW'
        else:
            return 'Open QW'


    def invoke(self, context, event):
        props = get_prefs()
        settings = context.scene.GP_scene_set

        if self.ufui:
            #print( 'ui' )
            if settings.qw:
                settings.qw = False
                #props.qw_pin = False
            else:
                x = context.area.width / 2
                y = context.area.height / 2
                settings.qw_pos = (x, y)
                settings.qw = True
                #props.qw_pin = True
        
        else:
            var.QW_ALIGN_STORE = settings.qw_alignment
            var.QW_STORE_POS = settings.qw_pos[:]
            var.QW_USED_OP = True
            settings.qw_alignment = 'CIRCLE'
            settings.qw_pos = (event.mouse_region_x, event.mouse_region_y)
            settings.qw = True
            

        """ if self.pin:
            props.qw_pin = True """

        if context.area:
            context.area.tag_redraw()
        
        return{'FINISHED'}


# --- ORIENTATION SWITCH
class GP_OT_orientation_switch(Operator):
    bl_idname = 'gp.orientation_switch'
    bl_label = 'Orientation'


    property: EnumProperty(
        name = 'Property',
        description = 'Props',
        items=[
            ('NONE', 'None', '', '', 0),
            ('GLOBAL', 'Orientation Global', '', '', 1),
            ('LOCAL', 'Orientation Local', '', '', 2),
            ('NORMAL', 'Orientation Normal', '', '', 3),
            ('GIMBAL', 'Orientation Gimbal', '', '', 4),
            ('VIEW', 'Orientation View', '', '', 5),
            ('CURSOR', 'Orientation Cursor', '', '', 6),
            ('PARENT', 'Orientation Parent', '', '', 7),
            ('PRO', 'Orientation Pro', '', '', 8),
            ],
            default = 'NONE',
            )


    @classmethod
    def description(self, context, properties):
        if properties.property == 'GLOBAL':
            return 'Global'
        elif properties.property == 'LOCAL':
            return 'Local'
        elif properties.property == 'NORMAL':
            return 'Normal'
        elif properties.property == 'GIMBAL':
            return 'Gimbal'
        elif properties.property == 'VIEW':
            return 'View'
        elif properties.property == 'CURSOR':
            return '3D Cursor'
        elif properties.property == 'PARENT':
            return 'Parent Orientation'
        elif properties.property == 'PRO':
            return 'Pro Orientation'
        elif properties.property == 'NONE':
            return 'Orientation Gizmo'


    def execute(self, context):
        bpy.ops.wm.context_set_enum( data_path = 'scene.transform_orientation_slots[0].type', value = self.property )
        # --- Выключение Quick Widget
        props = get_prefs()
        settings = context.scene.GP_scene_set
        if props.qw_disable: #  and props.qw_pin == False
            settings.qw = False
        return {'FINISHED'}


# --- POSITION SWITCH
class GP_OT_position_switch(Operator):
    bl_idname = 'gp.position_switch'
    bl_label = 'Pivot Point Position'


    property: EnumProperty(
        name='Property',
        description='Props',
        items=[
            ('NONE', 'None', '', '', 0),
            ('BOUNDING_BOX_CENTER', 'Bounding Box', '', '', 1),
            ('CURSOR', '3D Cursor', '', '', 2),
            ('INDIVIDUAL_ORIGINS', 'Idividual', '', '', 3),
            ('MEDIAN_POINT', 'Median', '', '', 4),
            ('ACTIVE_ELEMENT', 'Active', '', '', 5),
            ],
            default='NONE',
            )


    @classmethod
    def description(self, context, properties):
        if properties.property == 'BOUNDING_BOX_CENTER':
            return 'BB Center'

        elif properties.property == 'CURSOR':
            return '3D Cursor'
        
        elif properties.property == 'INDIVIDUAL_ORIGINS':
            return 'Individual Origins'

        elif properties.property == 'MEDIAN_POINT':
            return 'Median Point'

        elif properties.property == 'ACTIVE_ELEMENT':
            return 'Active Element'

        elif properties.property == 'NONE':
            return 'Position Gizmo'


    def execute(self, context):
        bpy.ops.wm.context_set_enum(data_path='scene.tool_settings.transform_pivot_point', value=self.property)
        # --- Выключение Quick Widget 
        props = get_prefs()
        settings = context.scene.GP_scene_set
        if props.qw_disable: #  and props.qw_pin == False
            settings.qw = False
        return {'FINISHED'}


# --- ACTION CENTER
class GP_MT_action_center(Menu):
    bl_label = 'Action Center'
    bl_description = 'Action Center'

    def draw(self, context):
        settings = context.scene.GP_scene_set
        
        layout = self.layout
        #pie = layout.menu_pie()
        layout.prop(settings, 'position', expand=True)
        

class GP_OT_position_ac_switch(Operator):
    bl_idname = 'gp.position_ac_switch'
    bl_label = 'Action Center'
    bl_description = 'Action Center'
    #bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        bpy.ops.wm.call_menu_pie(name = 'GP_MT_action_center')
        return {'FINISHED'}
  
        
# --- SNAP SWITCH
class GP_OT_snap_switch(Operator):
    bl_idname = 'gp.snap_switch'
    bl_label = 'Snap To'


    property: EnumProperty(
        name='Property',
        description='Props',
        items=[
            ('NONE', 'None', '', '', 0),
            ('INCREMENT', 'Increment', '', '', 1),
            ('VERTEX', 'Vertex', '', '', 2),
            ('EDGE', 'Edge', '', '', 3),
            ('FACE', 'Face', '', '', 4),
            ('VOLUME', 'Volume', '', '', 5),
            ('EDGE_MIDPOINT', 'Edge Center', '', '', 6),
            ('EDGE_PERPENDICULAR', 'Edge Perpendicular', '', '', 7),
            ],
            default='NONE',
            )


    @classmethod
    def description(self, context, properties):
        if properties.property == 'INCREMENT':
            return 'Increment'

        elif properties.property == 'VERTEX':
            return 'Vertex'
        
        elif properties.property == 'EDGE':
            return 'Edge'

        elif properties.property == 'FACE':
            return 'Face'

        elif properties.property == 'VOLUME':
            return 'Volume'

        elif properties.property == 'EDGE_MIDPOINT':
            return 'Edge Midpoint'

        elif properties.property == 'EDGE_PERPENDICULAR':
            return 'Edge Perpendicular'

        elif properties.property == 'NONE':
            return 'Snap To'


    def invoke(self, context, event):
        props = get_prefs()

        store = context.scene.tool_settings.snap_elements
        if event.shift:
            if self.property == 'INCREMENT':
                if self.property not in store:
                    store.add('INCREMENT')
                else:
                    store.remove('INCREMENT')

            elif self.property == 'VERTEX':
                if self.property not in store:
                    store.add('VERTEX')
                else:
                    store.remove('VERTEX')

            elif self.property == 'EDGE':
                if self.property not in store:
                    store.add('EDGE')
                else:
                    store.remove('EDGE')

            elif self.property == 'FACE':
                if self.property not in store:
                    store.add('FACE')
                else:
                    store.remove('FACE')

            elif self.property == 'VOLUME':
                if self.property not in store:
                    store.add('VOLUME')
                else:
                    store.remove('VOLUME')

            elif self.property == 'EDGE_MIDPOINT':
                if self.property not in store:
                    store.add('EDGE_MIDPOINT')
                else:
                    store.remove('EDGE_MIDPOINT')

            elif self.property == 'EDGE_PERPENDICULAR':
                if self.property not in store:
                    store.add('EDGE_PERPENDICULAR')
                else:
                    store.remove('EDGE_PERPENDICULAR')

            context.scene.tool_settings.snap_elements = store 

        else:
            if self.property == 'INCREMENT':
                context.scene.tool_settings.snap_elements = {'INCREMENT'}
            elif self.property == 'VERTEX':
                context.scene.tool_settings.snap_elements = {'VERTEX'}
            elif self.property == 'EDGE':
                context.scene.tool_settings.snap_elements = {'EDGE'}
            elif self.property == 'FACE':
                context.scene.tool_settings.snap_elements = {'FACE'}
            elif self.property == 'VOLUME':
                context.scene.tool_settings.snap_elements = {'VOLUME'}
            elif self.property == 'EDGE_MIDPOINT':
                context.scene.tool_settings.snap_elements = {'EDGE_MIDPOINT'}
            elif self.property == 'EDGE_PERPENDICULAR':
                context.scene.tool_settings.snap_elements = {'EDGE_PERPENDICULAR'}

        #bpy.context.scene.tool_settings.snap_elements = {'INCREMENT', 'VERTEX', 'EDGE', 'FACE', 'VOLUME', 'EDGE_MIDPOINT', 'EDGE_PERPENDICULAR'}

        context.area.tag_redraw()
        
        return {'FINISHED'}
    
    
# --- PIVOT TO
class GP_OT_pivot_set(Operator):
    bl_idname = 'gp.pivot_set'
    bl_label = 'Pivot To'
    bl_options = {'REGISTER', 'UNDO'}

    property: EnumProperty(
        name='Property',
        description='Props',
        items=[
            ('WORLD', 'World', '', '', 0),
            ('ORIGIN_GEOMETRY', 'Center Mesh', '', '', 1),
            ('ORIGIN_CURSOR', 'Cursor', '', '', 2),
            ],
            default='WORLD',
            )


    @classmethod
    def description(self, context, properties):
        if properties.property == 'WORLD':
            return 'Pivot To World'

        elif properties.property == 'ORIGIN_GEOMETRY':
            return 'Pivot To Center Of Geometry'
        
        elif properties.property == 'ORIGIN_CURSOR':
            return 'Pivot To 3D Cursor'
 

    def execute(self, context):
        edit = False
        if context.mode != 'OBJECT':
            edit = True
            bpy.ops.object.mode_set(mode='OBJECT')

        if self.property == 'WORLD':  
            bpy.ops.object.transform_apply(location=True, rotation=False, scale=False, properties=True)
        elif self.property == 'ORIGIN_GEOMETRY':
            bpy.ops.object.origin_set(type='ORIGIN_GEOMETRY')
        elif self.property == 'ORIGIN_CURSOR':
            bpy.ops.object.origin_set(type='ORIGIN_CURSOR') # , center='MEDIAN'


        if edit:
            bpy.ops.object.mode_set(mode='EDIT')
        
        # Выключение Quick Widget 
        props = get_prefs()
        settings = context.scene.GP_scene_set
        if props.qw_disable: #  and props.qw_pin == False
            settings.qw = False
        return {'FINISHED'}






# --- QW
class GP_OT_pin_qw(Operator):
    bl_idname = 'gp.pin_qw'
    bl_label = 'Pin QW'
    bl_description = 'Pin QW'
    #bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        props = get_prefs()
        if props.qw_pin:
            props.qw_pin = False
        else:
            props.qw_pin = True
 
        return {'FINISHED'}



class GP_OT_qw_brush(Operator):
    bl_idname = 'gp.qw_brush'
    bl_label = 'Brush'
    bl_description = ' '
    #bl_options = { 'REGISTER' } 
    type: StringProperty( default = 'BRUSH' )
    


    """ @classmethod
    def description(self, context, properties):
        
        if properties.name == 'VIEW3D_PT_proportional_edit':
            tp = transform_proportional(context)
            return tp[0] #'Proportional Edit'
        elif properties.name == 'VIEW3D_PT_snapping':
            tst = transform_snap_to(context)
            return tst[0] #'Snapping'
        elif properties.name == 'GP_PT_transform_positions':
            tpp = transform_pivot_point(context)
            return tpp[0] #'Transform Positions'
        elif properties.name == 'GP_PT_transform_orientations':
            to = transform_orientation(context)
            return to[0] #'Transform Orientations'
        elif properties.name == 'GP_PT_3d_cursor':
            return '3d Cursor'
        elif properties.name == 'OBJECT_PT_display':
            return 'Viewport Display'
        elif properties.name == 'VIEW3D_PT_tools_object_options':
            return 'Tools Object Options'
        elif properties.name == 'GP_PT_pivot_transform' or properties.name == 'PT_PT_transform_panel':
            return 'Pivot Transform' """


    def __init__(self):
        self._operator = 'BRUSH_SIZE'
        self._init_mouse = (0.0, 0.0)
        self._init_size = 0
        self._init_strength = 0.0
    

    @staticmethod
    def prop_unified(
            layout,
            context,
            brush,
            prop_name,
            unified_name=None,
            pressure_name=None,
            icon='NONE',
            text=None,
            slider=False,
            header=False,
        ):
        """ Generalized way of adding brush options to the UI,
            along with their pen pressure setting and global toggle, if they exist. """
        row = layout.row(align=True)
        ups = context.tool_settings.unified_paint_settings
        prop_owner = brush
        if unified_name and getattr(ups, unified_name):
            prop_owner = ups

        row.prop(prop_owner, prop_name, icon=icon, text=text, slider=slider)

        if pressure_name:
            row.prop(brush, pressure_name, text="")

        if unified_name and not header:
            # NOTE: We don't draw UnifiedPaintSettings in the header to reduce clutter. D5928#136281
            row.prop(ups, unified_name, text="", icon='BRUSHES_ALL')

        return row


    @staticmethod
    def prop_unified_color(parent, context, brush, prop_name, *, text=None):
        ups = context.tool_settings.unified_paint_settings
        prop_owner = ups if ups.use_unified_color else brush
        parent.prop(prop_owner, prop_name, text=text)


    @staticmethod
    def prop_unified_color_picker(parent, context, brush, prop_name, value_slider=True):
        ups = context.tool_settings.unified_paint_settings
        prop_owner = ups if ups.use_unified_color else brush
        parent.template_color_picker(prop_owner, prop_name, value_slider=value_slider)


    def modal(self, context, event):
        if context.area:
            context.area.tag_redraw()


        if event.type in {'RIGHTMOUSE', 'ESC'}:
            set_brush_size(self, context, self._init_size)
            set_brush_strength(self, context, self._init_strength)
            return {'CANCELLED'}


        if event.value == 'RELEASE' and event.type == 'LEFTMOUSE':
            return {'FINISHED'}


        if self._operator == 'BRUSH_SIZE':
            """ bs = self.get_brush_size( self, context )
            if bs < 50:
                k = 6
            elif bs < 120:
                k = 4
            else:
                k = 2 """
            k = 5
            delta = ( (event.mouse_x - self._init_mouse[0]) / k ) * -1
            if event.ctrl:
                value = round( int( self._init_size - delta ), -1 )
            elif event.shift:
                delta /= 10.0
                value = int( self._init_size - delta )
            else:
                value = int( self._init_size - delta )
            
            #print('value', value)
            set_brush_size(self, context, value)

        elif self._operator == 'BRUSH_STRENGTH':
            k = 400
            delta = ( (event.mouse_y - self._init_mouse[1]) / k ) * -1
            if event.ctrl:
                value = round( self._init_strength - delta , 1 )
            elif event.shift:
                delta /= 10.0
                value = self._init_strength - delta
            else:
                value = self._init_strength - delta

            set_brush_strength(self, context, value)


        return {'PASS_THROUGH'}


    def invoke(self, context, event):
        self._init_mouse = (event.mouse_x, event.mouse_y)
        
        if self.type == 'BRUSH':
            if event.value == 'CLICK':
                self._operator = 'BRUSH_SELECT'
                bpy.ops.wm.call_panel( name = 'IMAGE_PT_paint_select' )
                return {'CANCELLED'}
            elif event.direction in { 'WEST', 'EAST' }:
                self._operator = 'BRUSH_SIZE'
                self._init_size = get_brush_size( self, context )
            elif event.direction in { 'NORTH', 'SOUTH' }:
                self._operator = 'BRUSH_STRENGTH'
                self._init_strength = get_brush_strength(self, context)
            else:
                return {'CANCELLED'}

        elif self.type == 'COLOR':
            if event.value == 'CLICK':
                self._operator = 'COLOR_SELECT'
                bpy.ops.wm.call_panel( name = 'GP_PT_color_picker' )
                return {'FINISHED'}
            elif event.direction in { 'WEST', 'EAST' }:
                return {'CANCELLED'}
            elif event.direction in { 'NORTH', 'SOUTH' }:
                return {'CANCELLED'}
            else:
                return {'CANCELLED'}
        context.window_manager.modal_handler_add( self )
        return {'RUNNING_MODAL'}


  
            



# --- TO SELECT
def bone_select():
    C = bpy.context

    if C.mode in {'EDIT_ARMATURE'}:
        viewlayer = C.view_layer
        collection = C.scene.statistics(viewlayer).split(" | ")

        verts_sel = collection[1]
        verts_str = verts_sel[6:].replace(',', '')
        verts_get = verts_str.split("/")[0]

        bone_sel = collection[2]
        bone_str = bone_sel[6:].replace(',', '')
        bone_get = bone_str.split("/")[0]

        verts, bones = int(verts_get), int(bone_get)

    elif C.mode in {'POSE'}:
        viewlayer = C.view_layer
        collection = C.scene.statistics(viewlayer).split(" | ")

        bone_sel = collection[1]
        bone_str = bone_sel[6:].replace(',', '')
        bone_get = bone_str.split("/")[0]
        
        verts, bones = 0, int(bone_get)

    else:
        verts, bones = 0, 0
    

    return verts, bones


def activate():
    import bmesh
    context = bpy.context
    if len(context.selected_objects) > 0: #context.active_object != None and  context.object.select_get()
        if context.object.type == 'MESH':
            me = context.object.data
            if context.mode == 'EDIT_MESH':
                bm = bmesh.from_edit_mesh(me)
                items = [v for v in bm.verts if v.select]
            else:
                items = [v for v in me.vertices if v.select]


        elif context.mode in {'EDIT_ARMATURE'}:
                verts, bone = bone_select()
                if verts > 0:
                    items = [ verts ]
                elif bone > 0:
                    items = [ bone ]

        elif context.mode in {'POSE'}:
            bone = bone_select()[1]
            if bone > 0:
                items = [ bone ]
       

        elif context.object.type == 'CURVE':
            items = []
            for obj in context.selected_objects:
                for s in obj.data.splines:
                    for p in s.bezier_points:
                        if p.select_control_point:
                            items.append(p)
                        else:
                            if p.select_left_handle:
                                items.append(p)
                            if p.select_right_handle:
                                items.append(p)
        else:
            items = []

        v = len(items)
        
        #print(v)
        return v != 0


def pivot_to_select(context, loc=None):
    import mathutils
    cursor = context.scene.cursor
    cursor_pos = cursor.location.copy()

    rotation_mode = cursor.rotation_mode
    cursor.rotation_mode = 'XYZ'
    cursor_rot = cursor.rotation_euler.copy()

    cursor.rotation_quaternion =  context.region_data.view_rotation


    user_orient = context.window.scene.transform_orientation_slots[0].type
    
    if loc is None:
        bpy.ops.view3d.snap_cursor_to_selected()
    else:
        cursor.location = loc

    # Создание кастомной матрицы ориентации
    name = "PivotTransform"
    #context.window.scene.transform_orientation_slots[0].type = 'NORMAL'
    bpy.ops.transform.create_orientation(name=name, use=True, overwrite=True)
    user_matrix = context.scene.transform_orientation_slots[0].custom_orientation.matrix.to_4x4()
    

    # Изменение матрицы курсора
    center = mathutils.Matrix.Translation(context.scene.cursor.location)
    cursor.matrix = center @ user_matrix
    


    # Перемещение пивота только у активного объекта
    bpy.ops.object.mode_set(mode = 'OBJECT')

    activeObj = context.active_object
    selectObjs = context.selected_objects
    bpy.ops.object.select_all(action='DESELECT')
    
    activeObj.select_set(state=True)
    context.view_layer.objects.active = activeObj

    
    bpy.ops.pivot.apply() # Применение пивота

    for obj in selectObjs:
        obj.select_set(state=True)
    context.view_layer.objects.active = activeObj

    bpy.ops.object.mode_set(mode='EDIT')


    # Итоговое позиционирование курсора
    cursor.location = cursor_pos
    cursor.rotation_euler = cursor_rot
    cursor.rotation_mode = rotation_mode

    # Сброс к начальным настройкам пользовательских настроек
    context.window.scene.transform_orientation_slots[0].type = name
    bpy.ops.transform.delete_orientation('INVOKE_DEFAULT')
    context.window.scene.transform_orientation_slots[0].type = user_orient


class GP_OT_to_select(Operator):
    bl_idname = "gp.to_select"
    bl_label = "Pivot To Select"
    bl_description = ("Pivot To Select \n"
                     "And Normal Alignment"
    )
    bl_options = {'REGISTER', 'UNDO'}

    #align_to: BoolProperty(name='Normal Alignment', default=True)


    @classmethod
    def poll(self, context):
        if context.active_object != None:
            return activate()
        

    def execute(self, context):
        #if self.align_to:
        pivot_to_select(context)
            
        """ else:
            cursor = context.scene.cursor
            cursor_pos = cursor.location.copy()
            cursor_rot = cursor.rotation_euler.copy()

            bpy.ops.view3d.snap_cursor_to_selected()
            bpy.ops.object.editmode_toggle()
            bpy.ops.object.origin_set(type='ORIGIN_CURSOR', center='MEDIAN')
            bpy.ops.object.editmode_toggle()
            
            # Итоговое позиционирование курсора
            cursor.location = cursor_pos
            cursor.rotation_euler = cursor_rot """
        
        return {'FINISHED'}



















classes = [
    GP_OT_quick_wheel,
    GP_MT_action_center,
    GP_OT_position_ac_switch,
    GP_OT_snap_switch,
    GP_OT_to_select,
    GP_OT_qw_brush,
]



def register():
    for cls in classes:
        bpy.utils.register_class(cls)

   
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)