import bpy
from bpy.types import Operator
from .. import get_prefs


def update_version():
    import urllib, re, addon_utils

    page = urllib.request.urlopen( 'https://github.com/ilumetric/Poly_Source/blob/main/Versions' ).read()
    txt = str(page)

    version_site = re.search(r'GP\b......', txt)
    version = version_site[0][3:]

    addon_version = [addon.bl_info.get('version', (-1,-1,-1)) for addon in addon_utils.modules() if addon.bl_info['name'] == 'Gizmo PRO'][0]
    current_version = str(addon_version[0]) + '.' + str(addon_version[1]) + '.' + str(addon_version[2])
    print('Gizmo PRO: Current Version ' + current_version)
    if version <= current_version:
        return False, version
    else:
        return True, version



class GP_OT_check_updates(Operator):
    bl_idname = 'gp.check_updates'
    bl_label = 'Check Update'
    bl_description = 'Check If There Is An Update For The Addon'

    def execute(self, context):
        props = get_prefs()
        try:
            check, version = update_version()
            
            if check:
                props.update = True
                props.version = version
            else:
                props.update = False
        except:
            props.update = False
        return {'FINISHED'}



classes = [
    GP_OT_check_updates,
]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)  