import bpy
from bpy.app.handlers import persistent
from .. import var



# --- Отслеживангие изменения типа позиции гизмо
subscription_owner = object()

def update_matrix(*args):
    var.REFRESH_MAT = True


def subscribe_change_type_position(subscription_owner):
    bpy.msgbus.subscribe_rna(
        key=(bpy.types.ToolSettings, 'transform_pivot_point'),
        owner=bpy,
        args=(),
        notify = update_matrix,
        options={'PERSISTENT'},
    )

    # --- Register the persistent handler, ensures that the subscription will happen 
    # --- when a new file is loaded.
    if load_handler not in bpy.app.handlers.load_post:
        bpy.app.handlers.load_post.append(load_handler)


def unsubscribe_change_type_position(subscription_owner):
    # --- Clear all subscribers by this owner
    if subscription_owner is not None:
        bpy.msgbus.clear_by_owner(subscription_owner)

    # --- Unregister the persistent handler.
    if load_handler in bpy.app.handlers.load_post:
        bpy.app.handlers.load_post.remove(load_handler)



@persistent
def load_handler(dummy):
    subscribe_change_type_position(subscription_owner)







def register():
    # --- Subscribe and remove handle
    if load_handler not in bpy.app.handlers.load_post:
        bpy.app.handlers.load_post.append(load_handler)


def unregister():
    # --- Unsubscribe and remove handle
    unsubscribe_change_type_position(subscription_owner)