import bpy
from bpy.types import Macro, Operator

EDM = False
PPA = False


class GP_OT_align(Macro):
    bl_idname = 'gp.align'
    bl_label = 'Align'
    bl_options = {'REGISTER', 'UNDO'}


class GP_OT_align_store_set(Operator):
    bl_idname = 'gp.align_store_set'
    bl_label = 'Align'
    bl_options = {'INTERNAL'}

    def execute(self, context):
        global EDM
        global PPA
        
        EDM = True if context.mode == 'EDIT_MESH' else False
        PPA = context.scene.tool_settings.use_transform_pivot_point_align 
        return {'FINISHED'}


class GP_OT_align_store_get(Operator):
    bl_idname = 'gp.align_store_get'
    bl_label = 'Pivot Transform'
    bl_options = {'INTERNAL'}

    def execute(self, context):
        global PPA
        context.scene.tool_settings.use_transform_pivot_point_align = PPA
        bpy.ops.ed.undo_push(message='Gizmo PRO: Align')
        return {'FINISHED'}



classes = [
    GP_OT_align,
    GP_OT_align_store_set,
    GP_OT_align_store_get,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)

    
    GP_OT_align.define('GP_OT_align_store_set')

    """ op = GP_OT_align.define('OBJECT_OT_mode_set')
    op.properties.mode = 'OBJECT' """

    op = GP_OT_align.define('WM_OT_context_set_boolean')
    op.properties.data_path = 'scene.tool_settings.use_transform_pivot_point_align'
    

    GP_OT_align.define('TRANSFORM_OT_resize')
    
    GP_OT_align.define('GP_OT_align_store_get')


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)