import bpy
from bpy.types import Operator
from bpy.props import FloatProperty, EnumProperty

VALUE = 0.0



class GP_OT_calculator_math(Operator):
    bl_idname = 'gp.calculator_math'
    bl_label = 'Math'
    bl_options = {'REGISTER', 'UNDO'}
    
    func: EnumProperty(
        name = 'Function',
        items = (
            ('ADD', 'Add', 'Add'),
            ('SUB', 'Subtract', 'Subtract'),
            ('MUL', 'Multiply', 'Multiply'),
            ('DIV', 'Divide', 'Divide'),
        ),
        default = 'ADD',
    )

    value: FloatProperty(default=0.0)


    def execute(self, context):
        global VALUE
        if self.func == 'ADD':
            VALUE = context.scene.value_a + context.scene.value_b


        return {'FINISHED'}


class GP_OT_calculator(Operator):
    bl_idname = 'gp.calculator'
    bl_label = 'Calculator'
    bl_options = {'REGISTER', 'UNDO'}
    
    value: FloatProperty( name = 'Value', default = 0.0 )
    

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self)


    def execute(self, context):
        s = bpy.context.space_data


    def draw(self, context):
        layout = self.layout



        col = layout.column( align = False )

        row = col.row( align = False )
        row.prop( self, 'value')


        row = col.row( align = False )
        row.operator( 'gp.calculator_math', text = '+' )




















classes = [
    GP_OT_calculator,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)