import bpy
from bpy.types import Macro, Operator
from ... import var


class GP_OT_cursor_transform(Macro):
    bl_idname = 'gp.cursor_transform'
    bl_label = 'Cursor Transform'
    bl_options = {'UNDO'}



class GP_OT_refresh(Operator):
    bl_idname = 'gp.refresh'
    bl_label = 'Refresh Gizmo'
    def execute(self, context):
        var.REFRESH_MAT = True
        return {'FINISHED'}



classes = [
    GP_OT_cursor_transform,
    GP_OT_refresh,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)

    
    op = GP_OT_cursor_transform.define('VIEW3D_OT_cursor3d')
    op.properties.use_depth = True
    op.properties.orientation = 'GEOM'
    
    GP_OT_cursor_transform.define('GP_OT_refresh')

    op = GP_OT_cursor_transform.define('TRANSFORM_OT_translate')
    op.properties.cursor_transform = True
    op.properties.release_confirm = True
    op.properties.release_confirm = True
    #op.properties.snap_align = True
    """ ob = GP_OT_cursor_transform.define('TRANSFORM_OT_translate')
    ob.properties.release_confirm = True """


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls) 