import bpy
from bpy.types import Macro, Operator




class GP_OT_duplicate_rotate_mesh(Macro):
    bl_idname = 'gp.duplicate_rotate_mesh'
    bl_label = 'Duplicate And Rotate'
    bl_options = {'REGISTER', 'UNDO'}



class GP_OT_duplicate_rotate_object(Macro):
    bl_idname = 'gp.duplicate_rotate_object'
    bl_label = 'Duplicate And Rotate'
    bl_options = {'REGISTER', 'UNDO'}



classes = [
    GP_OT_duplicate_rotate_mesh,
    GP_OT_duplicate_rotate_object,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)

    
    GP_OT_duplicate_rotate_mesh.define('MESH_OT_duplicate')
    #op.properties.mode = 'ROTATION'
    GP_OT_duplicate_rotate_mesh.define('TRANSFORM_OT_rotate')
    
    
    
    op = GP_OT_duplicate_rotate_object.define('OBJECT_OT_duplicate')
    op.properties.mode = 'ROTATION'
    GP_OT_duplicate_rotate_object.define('TRANSFORM_OT_rotate')
    

def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls) 